Dashboards 1 endpoints

GET /projects/api/v3/dashboards.json

Return all dashboards that the logged-in user can access. Dashboards contains
panels that are used to summarize many activities from the installation.

operationId: Dashboards_getAll

Parameters

Name In Required Type Description
updatedAfter query optional string

filter by updated after date

orderMode query optional string

order mode

orderBy query optional string

order by

userId query optional integer

filter by user id

projectId query optional integer

filter by project id

pageSize query optional integer

number of items in a page

page query optional integer

page number

showDeleted query optional boolean

include deleted items

emoji query optional boolean

parse emoji alias to unicode

include query optional array

include

fields[users] query optional array
fields[projects] query optional array
fields[dashboards] query optional array
fields[dashboardSettings] query optional array
fields[dashboardPanels] query optional array
fields[dashboardPanelSettings] query optional array
dashboardIds query optional array

filter by user dashboard ids

Responses

200

200 OK

400

400 Bad Request

GET /projects/api/v3/dashboards.json

Features 1 endpoints

GET /projects/api/v3/features.json

Return all features accessible to the current installation.

operationId: Features_listAccessible

Responses

200

200 OK

400

400 Bad Request

GET /projects/api/v3/features.json

Filecomments 1 endpoints

GET /projects/api/v3/files/{fileId}/comments.json
operationId: FileComments_getList

Parameters

Name In Required Type Description
fileId path required integer

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

404

404 Not Found (no data)

GET /projects/api/v3/files/{fileId}/comments.json

Fileversioncomments 1 endpoints

GET /projects/api/v3/fileversions/{id}/comments.json
operationId: FileVersionComments_getList

Parameters

Name In Required Type Description
updatedAfterDate query optional string

filter by updated after date (deprecated, use updatedAfter)

updatedAfter query optional string

filter by updated after date

searchTerm query optional string

filter by comment content (like v1 filterText param)

publishedStartDate query optional string

filter by published after date

publishedEndDate query optional string

filter by published before date

orderMode query optional string

order mode

orderBy query optional string

order by

commentStatus query optional string

filter by commment status

pageSize query optional integer

number of items in a page

page query optional integer

page number

id path required integer
strictHTML query optional boolean

use strict html filtering fto content

getReactionsCount query optional boolean

get reactions count

userIds query optional array

filter by user ids

notifiedUserIds query optional array

filter by users who got notified for the comments

include query optional array

include

fields[users] query optional array

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

404

404 Not Found (no data)

GET /projects/api/v3/fileversions/{id}/comments.json

Forms 6 endpoints

GET /projects/api/v3/forms.json

Return a list of all forms.

operationId: Forms_getAll

Parameters

Name In Required Type Description
token.state query optional string

query by token state

searchTerm query optional string

filter by form name

orderMode query optional string

order mode

orderBy query optional string

order by

hostObject.type query optional string

query by hostObject type

content.state query optional string

query by form state

userId query optional integer

filter by user id

pageSize query optional integer

number of items in a page

page query optional integer

page number

hostObject.id query optional integer

filter by host id

skipCounts query optional boolean

SkipCounts allows you to skip doing counts on a list API endpoint for
performance reasons.

onlyProjectsWithExplicitMembership query optional boolean

filter only by project with direct membership

includeArchivedProjects query optional boolean

include archived projects

projectIds query optional array

filter by project ids

include query optional array

include

fields[users] query optional array
fields[tasklists] query optional array
fields[projects] query optional array
fields[forms] query optional array
fields[companies] query optional array

Responses

200

200 OK

400

400 Bad Request

GET /projects/api/v3/forms.json
POST /projects/api/v3/forms.json
operationId: Forms_createNewForm

Request Body

application/json
schema form.Request
Property Type Required
form object optional
content object optional
logo object optional
url string optional
name string optional
state string optional
banner object optional
x number optional
y number optional
url string optional
accentColor string optional
primaryColor string optional
definition string optional
description string optional
pendingLogoId string optional
pendingBannerId string optional
hostObject object optional
id integer optional
meta object optional
tasklistId integer optional
type string optional
redirectUrl string optional
primaryColor string optional
submitButtonText string optional
taskTitleFieldId string optional
destinationObject object optional
id integer optional
type string optional
confirmationMessage string optional
responseEmailFieldId string optional
allowTeamworkBranding boolean optional
promptAdditionalSubmissions boolean optional

Responses

201

201 Created

400

400 Bad Request

403

403 Forbidden

409

409 Conflict

POST /projects/api/v3/forms.json
DELETE /projects/api/v3/forms/{formId}.json
operationId: Forms_deleteExistingForm

Parameters

Name In Required Type Description
formId path required integer

Responses

204

204 No Content (no data)

403

403 Forbidden

404

404 Not Found (no data)

DELETE /projects/api/v3/forms/{formId}.json
GET /projects/api/v3/forms/{formId}.json
operationId: Forms_getSpecificForm

Parameters

Name In Required Type Description
formId path required integer

Responses

200

200 OK

403

403 Forbidden

404

404 Not Found (no data)

GET /projects/api/v3/forms/{formId}.json
PATCH /projects/api/v3/forms/{formId}.json
operationId: Forms_updateExistingForm

Parameters

Name In Required Type Description
formId path required integer

Request Body

application/json
schema form.Request
Property Type Required
form object optional
content object optional
logo object optional
url string optional
name string optional
state string optional
banner object optional
x number optional
y number optional
url string optional
accentColor string optional
primaryColor string optional
definition string optional
description string optional
pendingLogoId string optional
pendingBannerId string optional
hostObject object optional
id integer optional
meta object optional
tasklistId integer optional
type string optional
redirectUrl string optional
primaryColor string optional
submitButtonText string optional
taskTitleFieldId string optional
destinationObject object optional
id integer optional
type string optional
confirmationMessage string optional
responseEmailFieldId string optional
allowTeamworkBranding boolean optional
promptAdditionalSubmissions boolean optional

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

404

404 Not Found (no data)

409

409 Conflict

PATCH /projects/api/v3/forms/{formId}.json
GET /projects/api/v3/forms/{formId}/draft.json
operationId: Forms_getDraftForm

Parameters

Name In Required Type Description
formId path required integer

Responses

200

200 OK

403

403 Forbidden

404

404 Not Found (no data)

GET /projects/api/v3/forms/{formId}/draft.json

Formspublic 2 endpoints

GET /projects/api/v3/forms/public/{token}.json

This endpoint does not require authentication.

operationId: FormsPublic_getByToken

Parameters

Name In Required Type Description
token.state query optional string

query by token state

searchTerm query optional string

filter by form name

orderMode query optional string

order mode

orderBy query optional string

order by

hostObject.type query optional string

query by hostObject type

content.state query optional string

query by form state

userId query optional integer

filter by user id

token path required integer
pageSize query optional integer

number of items in a page

page query optional integer

page number

hostObject.id query optional integer

filter by host id

skipCounts query optional boolean

SkipCounts allows you to skip doing counts on a list API endpoint for
performance reasons.

onlyProjectsWithExplicitMembership query optional boolean

filter only by project with direct membership

includeArchivedProjects query optional boolean

include archived projects

projectIds query optional array

filter by project ids

include query optional array

include

fields[users] query optional array
fields[tasklists] query optional array
fields[projects] query optional array
fields[forms] query optional array
fields[companies] query optional array

Responses

200

200 OK

404

404 Not Found (no data)

GET /projects/api/v3/forms/public/{token}.json
POST /projects/api/v3/forms/{formID}/copy.json
operationId: FormsPublic_copyForm

Parameters

Name In Required Type Description
formID path required integer

Request Body

required
application/json
schema form.CopyRequest
Property Type Required
form object optional
title string optional
hostObject object optional
id integer optional
meta object optional
tasklistId integer optional
type string optional
projectIds array optional
copyAssignees boolean optional
generateToken boolean optional

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

404

404 Not Found (no data)

POST /projects/api/v3/forms/{formID}/copy.json

Importers 1 endpoints

GET /projects/api/v3/importer/stats.json

This endpoint returns info about a set of importers. This includes whether
they are individually running or not, what’s their status and a flag to
represent if any importer is running. The endpoint looks up redis for this
information. Using the parameter resetImporters this information can be
deleted in redis to reset it.

operationId: Importers_getStats

Parameters

Name In Required Type Description
resetImporters query optional boolean

reset importers

Responses

200

200 OK

400

400 Bad Request

GET /projects/api/v3/importer/stats.json

Messages 3 endpoints

GET /projects/api/v3/messages.json

Retrieve all messages for the provided filters.

operationId: Messages_getAll

Parameters

Name In Required Type Description
updatedAfter query optional string

filter by updated after date

searchTerm query optional string

filter by message name and body

projectType query optional string

filter by project type

projectStatuses query optional string

filter by project statuses

orderMode query optional string

order mode

orderBy query optional string

order by

createdBefore query optional string

filter by created before date

createdAfter query optional string

filter by created after date

pageSize query optional integer

number of items in a page

page query optional integer

page number

updatedAfterIncludesReplies query optional boolean

consider reply dates when using updatedAfter

unreadOnly query optional boolean

show unread messages only

skipCounts query optional boolean

SkipCounts allows you to skip doing counts on a list API endpoint for
performance reasons.

onlyStarredProjects query optional boolean

filter by starred projects only

matchAllTags query optional boolean

match all tags

matchAllProjectTags query optional boolean

match all project tags

includeDeleted query optional boolean

include deleted messages

includeArchivedProjects query optional boolean

include archived projects

getEmoji query optional boolean

parse emojis to unicode

formatMarkdown query optional boolean
archivedOnly query optional boolean

show archived messages only

userIds query optional array

filter by user ids

tagIds query optional array

filter by tag ids

projectTagIds query optional array

filter by project tag ids

projectOwnerIds query optional array

filter by project owner ids

projectIds query optional array

filter by project ids

projectHealths query optional array

filter by project healths

0: not set
1: bad
2: ok
3: good

projectCompanyIds query optional array

filter by company ids

projectCategoryIds query optional array

filter by project category ids

notifiedUserIds query optional array

filter by users who got notified for the messages

include query optional array

include

ids query optional array

filter by ids

fields[projects] query optional array
fields[messageReplies] query optional array
fields[companies] query optional array

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

GET /projects/api/v3/messages.json
GET /projects/api/v3/messages/{messageId}.json

Retrieves a message by id.

operationId: Messages_getSpecificMessage

Parameters

Name In Required Type Description
updatedAfter query optional string

filter by updated after date

searchTerm query optional string

filter by message name and body

projectType query optional string

filter by project type

projectStatuses query optional string

filter by project statuses

orderMode query optional string

order mode

orderBy query optional string

order by

createdBefore query optional string

filter by created before date

createdAfter query optional string

filter by created after date

pageSize query optional integer

number of items in a page

page query optional integer

page number

messageId path required integer
updatedAfterIncludesReplies query optional boolean

consider reply dates when using updatedAfter

unreadOnly query optional boolean

show unread messages only

skipCounts query optional boolean

SkipCounts allows you to skip doing counts on a list API endpoint for
performance reasons.

onlyStarredProjects query optional boolean

filter by starred projects only

matchAllTags query optional boolean

match all tags

matchAllProjectTags query optional boolean

match all project tags

includeDeleted query optional boolean

include deleted messages

includeArchivedProjects query optional boolean

include archived projects

getEmoji query optional boolean

parse emojis to unicode

formatMarkdown query optional boolean
archivedOnly query optional boolean

show archived messages only

userIds query optional array

filter by user ids

tagIds query optional array

filter by tag ids

projectTagIds query optional array

filter by project tag ids

projectOwnerIds query optional array

filter by project owner ids

projectIds query optional array

filter by project ids

projectHealths query optional array

filter by project healths

0: not set
1: bad
2: ok
3: good

projectCompanyIds query optional array

filter by company ids

projectCategoryIds query optional array

filter by project category ids

notifiedUserIds query optional array

filter by users who got notified for the messages

include query optional array

include

ids query optional array

filter by ids

fields[projects] query optional array
fields[messageReplies] query optional array
fields[companies] query optional array

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

404

404 Not Found

GET /projects/api/v3/messages/{messageId}.json
PATCH /projects/api/v3/messages/{messageId}.json

Update specific fields on a message. If the property read is sent with the
value true all replies from this message will be marked as read.

operationId: Messages_updateFields

Parameters

Name In Required Type Description
messageId path required integer

Request Body

required
application/json
schema message.Request
Property Type Required
read boolean optional

Responses

204

204 No Content (no data)

400

400 Bad Request

PATCH /projects/api/v3/messages/{messageId}.json

Milestonecomments 1 endpoints

GET /projects/api/v3/milestones/{milestoneId}/comments.json
operationId: MilestoneComments_getList

Parameters

Name In Required Type Description
milestoneId path required integer

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

404

404 Not Found (no data)

GET /projects/api/v3/milestones/{milestoneId}/comments.json

Milestones 8 endpoints

GET /projects/api/v3/milestones.json

All milestones are returned on projects that the authenticated user is
associated with. You can use the provided filters to return only those
milestones that are incomplete, completed, upcoming or late. All milestones
are returning in this call. This call uses pagination, returning 100
milestones per page by default.

operationId: Milestones_getAll

Parameters

Name In Required Type Description
updatedAfterDate query optional string

filter by updated after date (deprecated, use updatedAfter)

updatedAfter query optional string

filter by updated after date

searchTerm query optional string

filter by milestone name and description

reportType query optional string

define the type of the report

reportFormat query optional string

define the format of the report

projectStatus query optional string

filter by project status

orderMode query optional string

order mode

orderBy query optional string

order by

dueBeforeDate query optional string

filter by due before date (deprecated, use dueBefore)

dueBefore query optional string

filter by due before date

dueAfterDate query optional string

filter by due after date (deprecated, use dueAfter)

dueAfter query optional string

filter by due after date

pageSize query optional integer

number of items in a page

page query optional integer

page number

showPrivate query optional boolean

show private milestones

showDeleted query optional boolean

include deleted items

showAttachedTasklists query optional boolean

show attached tasklists

searchCompaniesTeams query optional boolean

include companies and teams in the search term

searchAssignees query optional boolean

include assignees in the search

progress query optional boolean

include percentage of tasks completed for all linked tasklists (deprecated, use includePercentageComplete)

onlyStarredProjects query optional boolean

filter by starred projects only

onlyMyProjects query optional boolean

filter by projects that the logged-in user is related

onlyAdminProjects query optional boolean

only include milestones from projects where the user is strictly a project admin.
site admins have visibility to all projects.

matchAllTags query optional boolean

match all milestone tags

matchAllProjectTags query optional boolean

match all project tags

isReportDownload query optional boolean

generate a report document

includeUpdate query optional boolean

include milestones latest update action

includeToday query optional boolean

include today when milestone status is upcoming

includeTeamUserIds query optional boolean

include team users to the responsible party ids

includeTags query optional boolean

include tags in the reports

includeProgress query optional boolean

include percentage of tasks completed for all linked tasklists (deprecated, use includePercentageComplete)

includePercentageComplete query optional boolean

include percentage of tasks completed for all linked tasklists

includeCompleted query optional boolean

optional to include completed milestones

includeCompanyUserIds query optional boolean

include company users to the responsible party ids

includeAssigneeTeams query optional boolean

include teams related to the responsible user ids

includeAssigneeCompanies query optional boolean

include companies related to the responsible user ids

includeArchivedProjects query optional boolean

include archived projects

emoji query optional boolean

convert emoji alias to unicode

countUnreadComments query optional boolean

count unread comments

calendar query optional boolean

enables the calendar style layout

tagIds query optional array

filter by milestone tag ids

status query optional array

filter by list of milestone status

selectedColumns query optional array

customise the report by selecting columns to be displayed.

projectTagIds query optional array

filter by project tag ids

projectStatuses query optional array

filter by list of project status

projectOwnerIds query optional array

filter by project owner ids

projectIds query optional array

filter by project ids

projectHealths query optional array

filter by list of project health

projectHealth query optional array

filter by list of project health (deprecated, use projectHealths)

projectCompanyIds query optional array

filter by company ids

projectCategoryIds query optional array

filter by project category ids

include query optional array

include

ids query optional array

filter by ids

followerIds query optional array

filter by followers’ ids

fields[users] query optional array
fields[tasklists] query optional array
fields[tags] query optional array
fields[projects] query optional array
fields[milestones] query optional array
fields[companies] query optional array
creatorIds query optional array

filter by creators’ ids

assignedToUserIds query optional array

filter by assigned user ids

assignedToTeamIds query optional array

filter by assigned team ids

assignedToCompanyIds query optional array

filter by assigned company ids

Responses

200

200 OK

400

400 Bad Request

GET /projects/api/v3/milestones.json
GET /projects/api/v3/milestones/metrics/deadlines.json

Count the number of milestones on each deadline date. Only the milestones
that the logged-in user can access will be included in the counting.

operationId: Milestones_getMilestonesByDueDate

Parameters

Name In Required Type Description
startDate query optional string
endDate query optional string

Responses

200

200 OK

400

400 Bad Request

GET /projects/api/v3/milestones/metrics/deadlines.json
GET /projects/api/v3/milestones/{milestonId}.json

This returns all details about an individual milestone.

operationId: Milestones_getById

Parameters

Name In Required Type Description
updatedAfterDate query optional string

filter by updated after date (deprecated, use updatedAfter)

updatedAfter query optional string

filter by updated after date

searchTerm query optional string

filter by milestone name and description

reportType query optional string

define the type of the report

reportFormat query optional string

define the format of the report

projectStatus query optional string

filter by project status

orderMode query optional string

order mode

orderBy query optional string

order by

dueBeforeDate query optional string

filter by due before date (deprecated, use dueBefore)

dueBefore query optional string

filter by due before date

dueAfterDate query optional string

filter by due after date (deprecated, use dueAfter)

dueAfter query optional string

filter by due after date

pageSize query optional integer

number of items in a page

page query optional integer

page number

milestonId path required integer
showPrivate query optional boolean

show private milestones

showDeleted query optional boolean

include deleted items

showAttachedTasklists query optional boolean

show attached tasklists

searchCompaniesTeams query optional boolean

include companies and teams in the search term

searchAssignees query optional boolean

include assignees in the search

progress query optional boolean

include percentage of tasks completed for all linked tasklists (deprecated, use includePercentageComplete)

onlyStarredProjects query optional boolean

filter by starred projects only

onlyMyProjects query optional boolean

filter by projects that the logged-in user is related

onlyAdminProjects query optional boolean

only include milestones from projects where the user is strictly a project admin.
site admins have visibility to all projects.

matchAllTags query optional boolean

match all milestone tags

matchAllProjectTags query optional boolean

match all project tags

isReportDownload query optional boolean

generate a report document

includeUpdate query optional boolean

include milestones latest update action

includeToday query optional boolean

include today when milestone status is upcoming

includeTeamUserIds query optional boolean

include team users to the responsible party ids

includeTags query optional boolean

include tags in the reports

includeProgress query optional boolean

include percentage of tasks completed for all linked tasklists (deprecated, use includePercentageComplete)

includePercentageComplete query optional boolean

include percentage of tasks completed for all linked tasklists

includeCompleted query optional boolean

optional to include completed milestones

includeCompanyUserIds query optional boolean

include company users to the responsible party ids

includeAssigneeTeams query optional boolean

include teams related to the responsible user ids

includeAssigneeCompanies query optional boolean

include companies related to the responsible user ids

includeArchivedProjects query optional boolean

include archived projects

emoji query optional boolean

convert emoji alias to unicode

countUnreadComments query optional boolean

count unread comments

calendar query optional boolean

enables the calendar style layout

tagIds query optional array

filter by milestone tag ids

status query optional array

filter by list of milestone status

selectedColumns query optional array

customise the report by selecting columns to be displayed.

projectTagIds query optional array

filter by project tag ids

projectStatuses query optional array

filter by list of project status

projectOwnerIds query optional array

filter by project owner ids

projectIds query optional array

filter by project ids

projectHealths query optional array

filter by list of project health

projectHealth query optional array

filter by list of project health (deprecated, use projectHealths)

projectCompanyIds query optional array

filter by company ids

projectCategoryIds query optional array

filter by project category ids

include query optional array

include

ids query optional array

filter by ids

followerIds query optional array

filter by followers’ ids

fields[users] query optional array
fields[tasklists] query optional array
fields[tags] query optional array
fields[projects] query optional array
fields[milestones] query optional array
fields[companies] query optional array
creatorIds query optional array

filter by creators’ ids

assignedToUserIds query optional array

filter by assigned user ids

assignedToTeamIds query optional array

filter by assigned team ids

assignedToCompanyIds query optional array

filter by assigned company ids

Responses

200

200 OK

400

400 Bad Request

GET /projects/api/v3/milestones/{milestonId}.json
GET /projects/api/v3/projects/{projectId}/milestones.json

This lets you query the list of milestones for a project. You can use the
provided filters to return only those milestones that are incomplete,
completed, upcoming or late. This call uses pagination, returning 100
milestones per page by default.

operationId: Milestones_list

Parameters

Name In Required Type Description
updatedAfterDate query optional string

filter by updated after date (deprecated, use updatedAfter)

updatedAfter query optional string

filter by updated after date

searchTerm query optional string

filter by milestone name and description

reportType query optional string

define the type of the report

reportFormat query optional string

define the format of the report

projectStatus query optional string

filter by project status

orderMode query optional string

order mode

orderBy query optional string

order by

dueBeforeDate query optional string

filter by due before date (deprecated, use dueBefore)

dueBefore query optional string

filter by due before date

dueAfterDate query optional string

filter by due after date (deprecated, use dueAfter)

dueAfter query optional string

filter by due after date

projectId path required integer
pageSize query optional integer

number of items in a page

page query optional integer

page number

showPrivate query optional boolean

show private milestones

showDeleted query optional boolean

include deleted items

showAttachedTasklists query optional boolean

show attached tasklists

searchCompaniesTeams query optional boolean

include companies and teams in the search term

searchAssignees query optional boolean

include assignees in the search

progress query optional boolean

include percentage of tasks completed for all linked tasklists (deprecated, use includePercentageComplete)

onlyStarredProjects query optional boolean

filter by starred projects only

onlyMyProjects query optional boolean

filter by projects that the logged-in user is related

onlyAdminProjects query optional boolean

only include milestones from projects where the user is strictly a project admin.
site admins have visibility to all projects.

matchAllTags query optional boolean

match all milestone tags

matchAllProjectTags query optional boolean

match all project tags

isReportDownload query optional boolean

generate a report document

includeUpdate query optional boolean

include milestones latest update action

includeToday query optional boolean

include today when milestone status is upcoming

includeTeamUserIds query optional boolean

include team users to the responsible party ids

includeTags query optional boolean

include tags in the reports

includeProgress query optional boolean

include percentage of tasks completed for all linked tasklists (deprecated, use includePercentageComplete)

includePercentageComplete query optional boolean

include percentage of tasks completed for all linked tasklists

includeCompleted query optional boolean

optional to include completed milestones

includeCompanyUserIds query optional boolean

include company users to the responsible party ids

includeAssigneeTeams query optional boolean

include teams related to the responsible user ids

includeAssigneeCompanies query optional boolean

include companies related to the responsible user ids

includeArchivedProjects query optional boolean

include archived projects

emoji query optional boolean

convert emoji alias to unicode

countUnreadComments query optional boolean

count unread comments

calendar query optional boolean

enables the calendar style layout

tagIds query optional array

filter by milestone tag ids

status query optional array

filter by list of milestone status

selectedColumns query optional array

customise the report by selecting columns to be displayed.

projectTagIds query optional array

filter by project tag ids

projectStatuses query optional array

filter by list of project status

projectOwnerIds query optional array

filter by project owner ids

projectIds query optional array

filter by project ids

projectHealths query optional array

filter by list of project health

projectHealth query optional array

filter by list of project health (deprecated, use projectHealths)

projectCompanyIds query optional array

filter by company ids

projectCategoryIds query optional array

filter by project category ids

include query optional array

include

ids query optional array

filter by ids

followerIds query optional array

filter by followers’ ids

fields[users] query optional array
fields[tasklists] query optional array
fields[tags] query optional array
fields[projects] query optional array
fields[milestones] query optional array
fields[companies] query optional array
creatorIds query optional array

filter by creators’ ids

assignedToUserIds query optional array

filter by assigned user ids

assignedToTeamIds query optional array

filter by assigned team ids

assignedToCompanyIds query optional array

filter by assigned company ids

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

GET /projects/api/v3/projects/{projectId}/milestones.json
GET /projects/api/v3/reporting/precanned/plannedvsactual/milestones.csv

Generates a milestone report in CSV format containing all milestones for the
provided filters. Only the milestones that the logged-in user can access will
be returned.

operationId: Milestones_generateCsvReport

Parameters

Name In Required Type Description
updatedAfterDate query optional string

filter by updated after date (deprecated, use updatedAfter)

updatedAfter query optional string

filter by updated after date

searchTerm query optional string

filter by milestone name and description

reportType query optional string

define the type of the report

reportFormat query optional string

define the format of the report

projectStatus query optional string

filter by project status

orderMode query optional string

order mode

orderBy query optional string

order by

dueBeforeDate query optional string

filter by due before date (deprecated, use dueBefore)

dueBefore query optional string

filter by due before date

dueAfterDate query optional string

filter by due after date (deprecated, use dueAfter)

dueAfter query optional string

filter by due after date

pageSize query optional integer

number of items in a page

page query optional integer

page number

showPrivate query optional boolean

show private milestones

showDeleted query optional boolean

include deleted items

showAttachedTasklists query optional boolean

show attached tasklists

searchCompaniesTeams query optional boolean

include companies and teams in the search term

searchAssignees query optional boolean

include assignees in the search

progress query optional boolean

include percentage of tasks completed for all linked tasklists (deprecated, use includePercentageComplete)

onlyStarredProjects query optional boolean

filter by starred projects only

onlyMyProjects query optional boolean

filter by projects that the logged-in user is related

onlyAdminProjects query optional boolean

only include milestones from projects where the user is strictly a project admin.
site admins have visibility to all projects.

matchAllTags query optional boolean

match all milestone tags

matchAllProjectTags query optional boolean

match all project tags

isReportDownload query optional boolean

generate a report document

includeUpdate query optional boolean

include milestones latest update action

includeToday query optional boolean

include today when milestone status is upcoming

includeTeamUserIds query optional boolean

include team users to the responsible party ids

includeTags query optional boolean

include tags in the reports

includeProgress query optional boolean

include percentage of tasks completed for all linked tasklists (deprecated, use includePercentageComplete)

includePercentageComplete query optional boolean

include percentage of tasks completed for all linked tasklists

includeCompleted query optional boolean

optional to include completed milestones

includeCompanyUserIds query optional boolean

include company users to the responsible party ids

includeAssigneeTeams query optional boolean

include teams related to the responsible user ids

includeAssigneeCompanies query optional boolean

include companies related to the responsible user ids

includeArchivedProjects query optional boolean

include archived projects

emoji query optional boolean

convert emoji alias to unicode

countUnreadComments query optional boolean

count unread comments

calendar query optional boolean

enables the calendar style layout

tagIds query optional array

filter by milestone tag ids

status query optional array

filter by list of milestone status

selectedColumns query optional array

customise the report by selecting columns to be displayed.

projectTagIds query optional array

filter by project tag ids

projectStatuses query optional array

filter by list of project status

projectOwnerIds query optional array

filter by project owner ids

projectIds query optional array

filter by project ids

projectHealths query optional array

filter by list of project health

projectHealth query optional array

filter by list of project health (deprecated, use projectHealths)

projectCompanyIds query optional array

filter by company ids

projectCategoryIds query optional array

filter by project category ids

include query optional array

include

ids query optional array

filter by ids

followerIds query optional array

filter by followers’ ids

fields[users] query optional array
fields[tasklists] query optional array
fields[tags] query optional array
fields[projects] query optional array
fields[milestones] query optional array
fields[companies] query optional array
creatorIds query optional array

filter by creators’ ids

assignedToUserIds query optional array

filter by assigned user ids

assignedToTeamIds query optional array

filter by assigned team ids

assignedToCompanyIds query optional array

filter by assigned company ids

Responses

200

200 OK (no data)

400

400 Bad Request

GET /projects/api/v3/reporting/precanned/plannedvsactual/milestones.csv
GET /projects/api/v3/reporting/precanned/plannedvsactual/milestones.html

Generates a milestone report in HTML format containing all milestones for the
provided filters. Only the milestones that the logged-in user can access will
be returned.

operationId: Milestones_generateHtmlReport

Parameters

Name In Required Type Description
updatedAfterDate query optional string

filter by updated after date (deprecated, use updatedAfter)

updatedAfter query optional string

filter by updated after date

searchTerm query optional string

filter by milestone name and description

reportType query optional string

define the type of the report

reportFormat query optional string

define the format of the report

projectStatus query optional string

filter by project status

orderMode query optional string

order mode

orderBy query optional string

order by

dueBeforeDate query optional string

filter by due before date (deprecated, use dueBefore)

dueBefore query optional string

filter by due before date

dueAfterDate query optional string

filter by due after date (deprecated, use dueAfter)

dueAfter query optional string

filter by due after date

pageSize query optional integer

number of items in a page

page query optional integer

page number

showPrivate query optional boolean

show private milestones

showDeleted query optional boolean

include deleted items

showAttachedTasklists query optional boolean

show attached tasklists

searchCompaniesTeams query optional boolean

include companies and teams in the search term

searchAssignees query optional boolean

include assignees in the search

progress query optional boolean

include percentage of tasks completed for all linked tasklists (deprecated, use includePercentageComplete)

onlyStarredProjects query optional boolean

filter by starred projects only

onlyMyProjects query optional boolean

filter by projects that the logged-in user is related

onlyAdminProjects query optional boolean

only include milestones from projects where the user is strictly a project admin.
site admins have visibility to all projects.

matchAllTags query optional boolean

match all milestone tags

matchAllProjectTags query optional boolean

match all project tags

isReportDownload query optional boolean

generate a report document

includeUpdate query optional boolean

include milestones latest update action

includeToday query optional boolean

include today when milestone status is upcoming

includeTeamUserIds query optional boolean

include team users to the responsible party ids

includeTags query optional boolean

include tags in the reports

includeProgress query optional boolean

include percentage of tasks completed for all linked tasklists (deprecated, use includePercentageComplete)

includePercentageComplete query optional boolean

include percentage of tasks completed for all linked tasklists

includeCompleted query optional boolean

optional to include completed milestones

includeCompanyUserIds query optional boolean

include company users to the responsible party ids

includeAssigneeTeams query optional boolean

include teams related to the responsible user ids

includeAssigneeCompanies query optional boolean

include companies related to the responsible user ids

includeArchivedProjects query optional boolean

include archived projects

emoji query optional boolean

convert emoji alias to unicode

countUnreadComments query optional boolean

count unread comments

calendar query optional boolean

enables the calendar style layout

tagIds query optional array

filter by milestone tag ids

status query optional array

filter by list of milestone status

selectedColumns query optional array

customise the report by selecting columns to be displayed.

projectTagIds query optional array

filter by project tag ids

projectStatuses query optional array

filter by list of project status

projectOwnerIds query optional array

filter by project owner ids

projectIds query optional array

filter by project ids

projectHealths query optional array

filter by list of project health

projectHealth query optional array

filter by list of project health (deprecated, use projectHealths)

projectCompanyIds query optional array

filter by company ids

projectCategoryIds query optional array

filter by project category ids

include query optional array

include

ids query optional array

filter by ids

followerIds query optional array

filter by followers’ ids

fields[users] query optional array
fields[tasklists] query optional array
fields[tags] query optional array
fields[projects] query optional array
fields[milestones] query optional array
fields[companies] query optional array
creatorIds query optional array

filter by creators’ ids

assignedToUserIds query optional array

filter by assigned user ids

assignedToTeamIds query optional array

filter by assigned team ids

assignedToCompanyIds query optional array

filter by assigned company ids

Responses

200

200 OK (no data)

400

400 Bad Request

GET /projects/api/v3/reporting/precanned/plannedvsactual/milestones.html
GET /projects/api/v3/reporting/precanned/plannedvsactual/milestones.pdf

Generates a milestone report in PDF format containing all milestones for the
provided filters. Only the milestones that the logged-in user can access will
be returned.

operationId: Milestones_generateMilestoneReportPdf

Parameters

Name In Required Type Description
updatedAfterDate query optional string

filter by updated after date (deprecated, use updatedAfter)

updatedAfter query optional string

filter by updated after date

searchTerm query optional string

filter by milestone name and description

reportType query optional string

define the type of the report

reportFormat query optional string

define the format of the report

projectStatus query optional string

filter by project status

orderMode query optional string

order mode

orderBy query optional string

order by

dueBeforeDate query optional string

filter by due before date (deprecated, use dueBefore)

dueBefore query optional string

filter by due before date

dueAfterDate query optional string

filter by due after date (deprecated, use dueAfter)

dueAfter query optional string

filter by due after date

pageSize query optional integer

number of items in a page

page query optional integer

page number

showPrivate query optional boolean

show private milestones

showDeleted query optional boolean

include deleted items

showAttachedTasklists query optional boolean

show attached tasklists

searchCompaniesTeams query optional boolean

include companies and teams in the search term

searchAssignees query optional boolean

include assignees in the search

progress query optional boolean

include percentage of tasks completed for all linked tasklists (deprecated, use includePercentageComplete)

onlyStarredProjects query optional boolean

filter by starred projects only

onlyMyProjects query optional boolean

filter by projects that the logged-in user is related

onlyAdminProjects query optional boolean

only include milestones from projects where the user is strictly a project admin.
site admins have visibility to all projects.

matchAllTags query optional boolean

match all milestone tags

matchAllProjectTags query optional boolean

match all project tags

isReportDownload query optional boolean

generate a report document

includeUpdate query optional boolean

include milestones latest update action

includeToday query optional boolean

include today when milestone status is upcoming

includeTeamUserIds query optional boolean

include team users to the responsible party ids

includeTags query optional boolean

include tags in the reports

includeProgress query optional boolean

include percentage of tasks completed for all linked tasklists (deprecated, use includePercentageComplete)

includePercentageComplete query optional boolean

include percentage of tasks completed for all linked tasklists

includeCompleted query optional boolean

optional to include completed milestones

includeCompanyUserIds query optional boolean

include company users to the responsible party ids

includeAssigneeTeams query optional boolean

include teams related to the responsible user ids

includeAssigneeCompanies query optional boolean

include companies related to the responsible user ids

includeArchivedProjects query optional boolean

include archived projects

emoji query optional boolean

convert emoji alias to unicode

countUnreadComments query optional boolean

count unread comments

calendar query optional boolean

enables the calendar style layout

tagIds query optional array

filter by milestone tag ids

status query optional array

filter by list of milestone status

selectedColumns query optional array

customise the report by selecting columns to be displayed.

projectTagIds query optional array

filter by project tag ids

projectStatuses query optional array

filter by list of project status

projectOwnerIds query optional array

filter by project owner ids

projectIds query optional array

filter by project ids

projectHealths query optional array

filter by list of project health

projectHealth query optional array

filter by list of project health (deprecated, use projectHealths)

projectCompanyIds query optional array

filter by company ids

projectCategoryIds query optional array

filter by project category ids

include query optional array

include

ids query optional array

filter by ids

followerIds query optional array

filter by followers’ ids

fields[users] query optional array
fields[tasklists] query optional array
fields[tags] query optional array
fields[projects] query optional array
fields[milestones] query optional array
fields[companies] query optional array
creatorIds query optional array

filter by creators’ ids

assignedToUserIds query optional array

filter by assigned user ids

assignedToTeamIds query optional array

filter by assigned team ids

assignedToCompanyIds query optional array

filter by assigned company ids

Responses

200

200 OK (no data)

400

400 Bad Request

GET /projects/api/v3/reporting/precanned/plannedvsactual/milestones.pdf
GET /projects/api/v3/reporting/precanned/plannedvsactual/milestones.xlsx

Generates a milestone report in XLSX format containing all milestones for the
provided filters. Only the milestones that the logged-in user can access will
be returned.

operationId: Milestones_generateXlsxReport

Parameters

Name In Required Type Description
updatedAfterDate query optional string

filter by updated after date (deprecated, use updatedAfter)

updatedAfter query optional string

filter by updated after date

searchTerm query optional string

filter by milestone name and description

reportType query optional string

define the type of the report

reportFormat query optional string

define the format of the report

projectStatus query optional string

filter by project status

orderMode query optional string

order mode

orderBy query optional string

order by

dueBeforeDate query optional string

filter by due before date (deprecated, use dueBefore)

dueBefore query optional string

filter by due before date

dueAfterDate query optional string

filter by due after date (deprecated, use dueAfter)

dueAfter query optional string

filter by due after date

pageSize query optional integer

number of items in a page

page query optional integer

page number

showPrivate query optional boolean

show private milestones

showDeleted query optional boolean

include deleted items

showAttachedTasklists query optional boolean

show attached tasklists

searchCompaniesTeams query optional boolean

include companies and teams in the search term

searchAssignees query optional boolean

include assignees in the search

progress query optional boolean

include percentage of tasks completed for all linked tasklists (deprecated, use includePercentageComplete)

onlyStarredProjects query optional boolean

filter by starred projects only

onlyMyProjects query optional boolean

filter by projects that the logged-in user is related

onlyAdminProjects query optional boolean

only include milestones from projects where the user is strictly a project admin.
site admins have visibility to all projects.

matchAllTags query optional boolean

match all milestone tags

matchAllProjectTags query optional boolean

match all project tags

isReportDownload query optional boolean

generate a report document

includeUpdate query optional boolean

include milestones latest update action

includeToday query optional boolean

include today when milestone status is upcoming

includeTeamUserIds query optional boolean

include team users to the responsible party ids

includeTags query optional boolean

include tags in the reports

includeProgress query optional boolean

include percentage of tasks completed for all linked tasklists (deprecated, use includePercentageComplete)

includePercentageComplete query optional boolean

include percentage of tasks completed for all linked tasklists

includeCompleted query optional boolean

optional to include completed milestones

includeCompanyUserIds query optional boolean

include company users to the responsible party ids

includeAssigneeTeams query optional boolean

include teams related to the responsible user ids

includeAssigneeCompanies query optional boolean

include companies related to the responsible user ids

includeArchivedProjects query optional boolean

include archived projects

emoji query optional boolean

convert emoji alias to unicode

countUnreadComments query optional boolean

count unread comments

calendar query optional boolean

enables the calendar style layout

tagIds query optional array

filter by milestone tag ids

status query optional array

filter by list of milestone status

selectedColumns query optional array

customise the report by selecting columns to be displayed.

projectTagIds query optional array

filter by project tag ids

projectStatuses query optional array

filter by list of project status

projectOwnerIds query optional array

filter by project owner ids

projectIds query optional array

filter by project ids

projectHealths query optional array

filter by list of project health

projectHealth query optional array

filter by list of project health (deprecated, use projectHealths)

projectCompanyIds query optional array

filter by company ids

projectCategoryIds query optional array

filter by project category ids

include query optional array

include

ids query optional array

filter by ids

followerIds query optional array

filter by followers’ ids

fields[users] query optional array
fields[tasklists] query optional array
fields[tags] query optional array
fields[projects] query optional array
fields[milestones] query optional array
fields[companies] query optional array
creatorIds query optional array

filter by creators’ ids

assignedToUserIds query optional array

filter by assigned user ids

assignedToTeamIds query optional array

filter by assigned team ids

assignedToCompanyIds query optional array

filter by assigned company ids

Responses

200

200 OK (no data)

400

400 Bad Request

GET /projects/api/v3/reporting/precanned/plannedvsactual/milestones.xlsx

Notebookcomments 1 endpoints

GET /projects/api/v3/notebooks/{notebookId}/comments.json
operationId: NotebookComments_getList

Parameters

Name In Required Type Description
notebookId path required integer

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

404

404 Not Found (no data)

GET /projects/api/v3/notebooks/{notebookId}/comments.json

Notebooks 11 endpoints

GET /projects/api/v3/notebooks.json
operationId: Notebooks_listNotebooks

Parameters

Name In Required Type Description
updatedAfterDate query optional string

filter by updated after date (deprecated, use updatedAfter)

updatedAfter query optional string

filter by updated after date

searchTerm query optional string

filter by notebook name and description

projectType query optional string

filter by project type

projectStatuses query optional string

filter by project statuses

orderMode query optional string

order mode

orderBy query optional string

order by

createdAfterDate query optional string

filter by created after date (deprecated, use createdAfter)

createdAfter query optional string

filter by created after date

pageSize query optional integer

number of items in a page

page query optional integer

page number

showDeleted query optional boolean

include deleted items

secureOnly query optional boolean

filter by showing only secure notebooks

matchAllTags query optional boolean

match all notebook tags

matchAllProjectTags query optional boolean

match all project tags

lockedOnly query optional boolean

filter by showing only locked notebooks

includeContents query optional boolean

include contents.

includeArchivedProjects query optional boolean

include archived projects

getEmoji query optional boolean

parse emojis to unicode

tagIds query optional array

filter by notebook tag ids

projectTagIds query optional array

filter by project tag ids

projectOwnerIds query optional array

filter by project owner ids

projectIds query optional array

filter by project ids

projectHealths query optional array

filter by project healths

0: not set
1: bad
2: ok
3: good

projectCompanyIds query optional array

filter by company ids

projectCategoryIds query optional array

filter by project category ids

include query optional array

include

ids query optional array

filter by ids

fields[users] query optional array
fields[teams] query optional array
fields[tags] query optional array
fields[projects] query optional array
fields[notebooks] query optional array
fields[notebookCategories] query optional array
fields[companies] query optional array
creatorIds query optional array

filter by creators’ ids

categoryIds query optional array

filter by notebook category ids

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

404

404 Not Found (no data)

GET /projects/api/v3/notebooks.json
DELETE /projects/api/v3/notebooks/{notebookId}.json
operationId: Notebooks_deleteExistingNotebook

Parameters

Name In Required Type Description
notebookId path required integer

Responses

204

204 No Content (no data)

400

400 Bad Request

403

403 Forbidden

404

404 Not Found (no data)

DELETE /projects/api/v3/notebooks/{notebookId}.json
GET /projects/api/v3/notebooks/{notebookId}.json
operationId: Notebooks_getSpecificNotebook

Parameters

Name In Required Type Description
updatedAfterDate query optional string

filter by updated after date (deprecated, use updatedAfter)

updatedAfter query optional string

filter by updated after date

projectType query optional string

filter by project type

notebookId path required integer
showDeleted query optional boolean

show deleted notebooks

getEmoji query optional boolean

parse emojis to unicode

include query optional array

include

fields[users] query optional array
fields[teams] query optional array
fields[tags] query optional array
fields[projects] query optional array
fields[notebooks] query optional array
fields[notebookCategories] query optional array
fields[companies] query optional array

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

404

404 Not Found (no data)

GET /projects/api/v3/notebooks/{notebookId}.json
PATCH /projects/api/v3/notebooks/{notebookId}.json

Edits the fields of an existing notebook.

operationId: Notebooks_editFields

Parameters

Name In Required Type Description
notebookId path required integer
getEmoji query optional boolean

parse emojis to unicode

include query optional array

include

fields[users] query optional array
fields[teams] query optional array
fields[tags] query optional array
fields[projects] query optional array
fields[notebooks] query optional array
fields[notebookCategories] query optional array
fields[companies] query optional array

Request Body

application/json
schema notebook.Request
Property Type Required
notebook object optional
name string optional
type string optional
locked boolean optional
notify object optional
ids object optional
teamIds object optional
userIds object optional
companyIds object optional
type object optional
Set boolean optional
Null boolean optional
Value string optional
tagIds array optional
privacy object optional
teamIds object optional
Set boolean optional
Null boolean optional
Value array optional
userIds object optional
Set boolean optional
Null boolean optional
Value array optional
companyIds object optional
Set boolean optional
Null boolean optional
Value array optional
contents string optional
sendDiff boolean optional
isPrivate boolean optional
categoryId integer optional
newVersion boolean optional
description string optional
isFullWidth boolean optional
secureContent boolean optional
notifyCurrentUser boolean optional

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

404

404 Not Found (no data)

PATCH /projects/api/v3/notebooks/{notebookId}.json
GET /projects/api/v3/notebooks/{notebookId}/compare.json

Gets the contents diff between the contents of 2 notebook versions

operationId: Notebooks_compareVersionsContentDiff

Parameters

Name In Required Type Description
notebookId path required integer
include query optional array

include

fields[users] query optional array

Responses

200

200 OK

400

400 Bad Request

404

404 Not Found (no data)

GET /projects/api/v3/notebooks/{notebookId}/compare.json
PUT /projects/api/v3/notebooks/{notebookId}/lock.json

Locks a specific notebook.

operationId: Notebooks_lockNotebook

Parameters

Name In Required Type Description
notebookId path required integer

Responses

200

200 OK (no data)

400

400 Bad Request

403

403 Forbidden

404

404 Not Found (no data)

PUT /projects/api/v3/notebooks/{notebookId}/lock.json
PUT /projects/api/v3/notebooks/{notebookId}/unlock.json

Unlocks a specific notebook.

operationId: Notebooks_unlockNotebook

Parameters

Name In Required Type Description
notebookId path required integer

Responses

200

200 OK (no data)

400

400 Bad Request

403

403 Forbidden

404

404 Not Found (no data)

PUT /projects/api/v3/notebooks/{notebookId}/unlock.json
DELETE /projects/api/v3/notebooks/{notebookId}/versions.json

Deletes some existing versions of a notebook by version ID.

operationId: Notebooks_deleteVersions

Parameters

Name In Required Type Description
notebookId path required integer

Responses

204

204 No Content (no data)

400

400 Bad Request

403

403 Forbidden

404

404 Not Found (no data)

DELETE /projects/api/v3/notebooks/{notebookId}/versions.json
GET /projects/api/v3/notebooks/{notebookId}/versions.json

Get a list of a notebooks versions.

operationId: Notebooks_getVersionsList

Parameters

Name In Required Type Description
notebookId path required integer
include query optional array

include

fields[users] query optional array

Responses

200

200 OK

400

400 Bad Request

404

404 Not Found (no data)

GET /projects/api/v3/notebooks/{notebookId}/versions.json
GET /projects/api/v3/notebooks/{notebookId}/versions/{versionId}.json

Get a specific notebook version.

operationId: Notebooks_getVersion

Parameters

Name In Required Type Description
versionId path required integer
notebookId path required integer
include query optional array

include

fields[users] query optional array

Responses

200

200 OK

400

400 Bad Request

404

404 Not Found (no data)

GET /projects/api/v3/notebooks/{notebookId}/versions/{versionId}.json
POST /projects/api/v3/projects/{projectId}/notebooks.json
operationId: Notebooks_createNewNotebook

Parameters

Name In Required Type Description
projectId path required integer
getEmoji query optional boolean

parse emojis to unicode

include query optional array

include

fields[users] query optional array
fields[teams] query optional array
fields[tags] query optional array
fields[projects] query optional array
fields[notebooks] query optional array
fields[notebookCategories] query optional array
fields[companies] query optional array

Request Body

application/json
schema notebook.Request
Property Type Required
notebook object optional
name string optional
type string optional
locked boolean optional
notify object optional
ids object optional
teamIds object optional
userIds object optional
companyIds object optional
type object optional
Set boolean optional
Null boolean optional
Value string optional
tagIds array optional
privacy object optional
teamIds object optional
Set boolean optional
Null boolean optional
Value array optional
userIds object optional
Set boolean optional
Null boolean optional
Value array optional
companyIds object optional
Set boolean optional
Null boolean optional
Value array optional
contents string optional
sendDiff boolean optional
isPrivate boolean optional
categoryId integer optional
newVersion boolean optional
description string optional
isFullWidth boolean optional
secureContent boolean optional
notifyCurrentUser boolean optional

Responses

201

201 Created

400

400 Bad Request

403

403 Forbidden

POST /projects/api/v3/projects/{projectId}/notebooks.json

People 11 endpoints

GET /projects/api/v3/people.json

Retrieve all people for the provided filters.

operationId: People_getAll

Parameters

Name In Required Type Description
userType query optional string

user type

updatedAfter query optional string

date time

searchTerm query optional string

filter by comment content

orderMode query optional string

order mode

orderBy query optional string

order by

lastLoginAfter query optional string
pageSize query optional integer

number of items in a page (not used when generating reports)

page query optional integer

page number (not used when generating reports)

skipCounts query optional boolean

SkipCounts allows you to skip doing counts on a list API endpoint for
performance reasons.

showDeleted query optional boolean

include deleted items

orderPrioritiseCurrentUser query optional boolean

Force to have the current/session user in the response

onlySiteOwner query optional boolean
onlyOwnerCompany query optional boolean

return people only from the owner company. This will replace any provided
company ID.

includeServiceAccounts query optional boolean

include service accounts

includeCollaborators query optional boolean

exclude collaborators types, returning only account and contact.

includeClients query optional boolean

include clients

filterByNoCostRate query optional boolean

Returns users who are missing cost rates(OCA only)

excludeContacts query optional boolean

exclude contact types, returning only account and collaborator.

teamIds query optional array

team ids

projectIds query optional array

filter by project ids

include query optional array

include (not used when generating reports)

ids query optional array

filter by user ids

fields[teams] query optional array
fields[person] query optional array
fields[people] query optional array
fields[companies] query optional array
fields[ProjectPermissions] query optional array
excludeProjectIds query optional array

exclude people assigned to certain project id

companyIds query optional array

company ids

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

GET /projects/api/v3/people.json
GET /projects/api/v3/people/metrics/performance.json

Count the number of completed tasks by user for the provided period. By
default the user with the most completed tasks is shown first.

operationId: People_listCompletedUserTasks

Parameters

Name In Required Type Description
startDate query optional string
orderMode query optional string

order mode

endDate query optional string

Responses

200

200 OK

400

400 Bad Request

GET /projects/api/v3/people/metrics/performance.json
GET /projects/api/v3/people/utilization.json

Verify the user utilization.

operationId: People_getUserUtilization

Parameters

Name In Required Type Description
zoom query optional string

determine the type of zoom filter used to display on the report

startDate query optional string

filter by start date

sortOrder query optional string

order mode

sort query optional string

sort by (deprecated, use orderBy)

searchTerm query optional string

filter by user first or last name

reportFormat query optional string

define the format of the report

orderMode query optional string

group by

orderBy query optional string

sort by

groupBy query optional string

group by

endDate query optional string

filter by end date

pageSize query optional integer

number of items in a page

page query optional integer

page number

skipCounts query optional boolean

SkipCounts allows you to skip doing counts on a list API endpoint for
performance reasons.

isReportDownload query optional boolean

generate a report document

isCustomDateRange query optional boolean

determine if the query is for a custom date range

includeCollaborators query optional boolean

include collaborators

includeClients query optional boolean

include client users

userIds query optional array

filter by userIds

teamIds query optional array

filter by team ids

selectedColumns query optional array

customise the report by selecting columns to be displayed.

projectIds query optional array

filter by project ids

include query optional array

include

fields[utilizations] query optional array
fields[users] query optional array
companyIds query optional array

filter by company ids

Responses

200

200 OK

400

400 Bad Request

404

404 Not Found (no data)

GET /projects/api/v3/people/utilization.json
DELETE /projects/api/v3/people/{personId}.json

Delete a person.

operationId: People_deletePerson

Parameters

Name In Required Type Description
personId path required integer

Responses

204

204 No Content (no data)

400

400 Bad Request

403

403 Forbidden

404

404 Not Found (no data)

DELETE /projects/api/v3/people/{personId}.json
GET /projects/api/v3/projects/{projectId}/people.json

Retrieve all people on the project.

operationId: People_getAllOnProject

Parameters

Name In Required Type Description
userType query optional string

user type

updatedAfter query optional string

date time

searchTerm query optional string

filter by comment content

orderMode query optional string

order mode

orderBy query optional string

order by

lastLoginAfter query optional string
projectId path required integer
pageSize query optional integer

number of items in a page (not used when generating reports)

page query optional integer

page number (not used when generating reports)

skipCounts query optional boolean

SkipCounts allows you to skip doing counts on a list API endpoint for
performance reasons.

showDeleted query optional boolean

include deleted items

orderPrioritiseCurrentUser query optional boolean

Force to have the current/session user in the response

onlySiteOwner query optional boolean
onlyOwnerCompany query optional boolean

return people only from the owner company. This will replace any provided
company ID.

includeServiceAccounts query optional boolean

include service accounts

includeObservers query optional boolean

include project observers

includeCollaborators query optional boolean

exclude collaborators types, returning only account and contact.

includeClients query optional boolean

include clients

filterByNoCostRate query optional boolean

Returns users who are missing cost rates(OCA only)

excludeContacts query optional boolean

exclude contact types, returning only account and collaborator.

teamIds query optional array

team ids

projectIds query optional array

filter by project ids

include query optional array

include (not used when generating reports)

ids query optional array

filter by user ids

fields[teams] query optional array
fields[person] query optional array
fields[people] query optional array
fields[companies] query optional array
fields[ProjectPermissions] query optional array
excludeProjectIds query optional array

exclude people assigned to certain project id

companyIds query optional array

company ids

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

GET /projects/api/v3/projects/{projectId}/people.json
PUT /projects/api/v3/projects/{projectId}/people.json

Adds a list of user ID’s to a project.

operationId: People_addToProject

Parameters

Name In Required Type Description
projectId path required integer

Request Body

required
application/json
schema people.UsersPayload
Property Type Required
userIds array optional
checkTeamIds array optional

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

PUT /projects/api/v3/projects/{projectId}/people.json
GET /projects/api/v3/reporting/precanned/usertaskcompletion.json

Retrieve all people for the provided filters and their task completions.

operationId: People_getTaskCompletions

Parameters

Name In Required Type Description
userType query optional string

user type

updatedAfter query optional string

date time

startDate query optional string

start date for task completion report

searchTerm query optional string

filter by comment content

reportFormat query optional string

define the format of the report

orderMode query optional string

order mode

orderBy query optional string

order by

lastLoginAfter query optional string
endDate query optional string

end date for task completion report

pageSize query optional integer

number of items in a page (not used when generating reports)

page query optional integer

page number (not used when generating reports)

skipCounts query optional boolean

SkipCounts allows you to skip doing counts on a list API endpoint for
performance reasons.

showDeleted query optional boolean

include deleted items

orderPrioritiseCurrentUser query optional boolean

Force to have the current/session user in the response

onlySiteOwner query optional boolean
onlyOwnerCompany query optional boolean

return people only from the owner company. This will replace any provided
company ID.

isReportDownload query optional boolean

generate a report document

includeServiceAccounts query optional boolean

include service accounts

includeCollaborators query optional boolean

exclude collaborators types, returning only account and contact.

includeClients query optional boolean

include clients

filterByNoCostRate query optional boolean

Returns users who are missing cost rates(OCA only)

excludeContacts query optional boolean

exclude contact types, returning only account and collaborator.

teamIds query optional array

team ids

selectedColumns query optional array

customise the report by selecting columns

projectIds query optional array

filter by project ids

include query optional array

include (not used when generating reports)

ids query optional array

filter by user ids

fields[teams] query optional array
fields[person] query optional array
fields[people] query optional array
fields[companies] query optional array
fields[ProjectPermissions] query optional array
excludeProjectIds query optional array

exclude people assigned to certain project id

companyIds query optional array

company ids

Responses

200

200 OK

400

400 Bad Request

403

403 Forbidden

GET /projects/api/v3/reporting/precanned/usertaskcompletion.json
GET /projects/api/v3/reporting/precanned/utilization.csv

Generates a utilization report in CSV format containing all people for the
provided filters. Only the people that the logged-in user can access will
be returned.

operationId: People_getUtilizationReportCsv

Parameters

Name In Required Type Description
zoom query optional string

determine the type of zoom filter used to display on the report

startDate query optional string

filter by start date

sortOrder query optional string

order mode

sort query optional string

sort by (deprecated, use orderBy)

searchTerm query optional string

filter by user first or last name

reportFormat query optional string

define the format of the report

orderMode query optional string

group by

orderBy query optional string

sort by

groupBy query optional string

group by

endDate query optional string

filter by end date

pageSize query optional integer

number of items in a page

page query optional integer

page number

skipCounts query optional boolean

SkipCounts allows you to skip doing counts on a list API endpoint for
performance reasons.

isReportDownload query optional boolean

generate a report document

isCustomDateRange query optional boolean

determine if the query is for a custom date range

includeCollaborators query optional boolean

include collaborators

includeClients query optional boolean

include client users

userIds query optional array

filter by userIds

teamIds query optional array

filter by team ids

selectedColumns query optional array

customise the report by selecting columns to be displayed.

projectIds query optional array

filter by project ids

include query optional array

include

fields[utilizations] query optional array
fields[users] query optional array
companyIds query optional array

filter by company ids

Responses

200

200 OK (no data)

400

400 Bad Request

GET /projects/api/v3/reporting/precanned/utilization.csv
GET /projects/api/v3/reporting/precanned/utilization.html

Generates a utilization report in HTML format containing all people for the
provided filters. Only the people that the logged-in user can access will
be returned.

operationId: People_generateUtilizationReportHtml

Parameters

Name In Required Type Description
zoom query optional string

determine the type of zoom filter used to display on the report

startDate query optional string

filter by start date

sortOrder query optional string

order mode

sort query optional string

sort by (deprecated, use orderBy)

searchTerm query optional string

filter by user first or last name

reportFormat query optional string

define the format of the report

orderMode query optional string

group by

orderBy query optional string

sort by

groupBy query optional string

group by

endDate query optional string

filter by end date

pageSize query optional integer

number of items in a page

page query optional integer

page number

skipCounts query optional boolean

SkipCounts allows you to skip doing counts on a list API endpoint for
performance reasons.

isReportDownload query optional boolean

generate a report document

isCustomDateRange query optional boolean

determine if the query is for a custom date range

includeCollaborators query optional boolean

include collaborators

includeClients query optional boolean

include client users

userIds query optional array

filter by userIds

teamIds query optional array

filter by team ids

selectedColumns query optional array

customise the report by selecting columns to be displayed.

projectIds query optional array

filter by project ids

include query optional array

include

fields[utilizations] query optional array
fields[users] query optional array
companyIds query optional array

filter by company ids

Responses

200

200 OK (no data)

400

400 Bad Request

GET /projects/api/v3/reporting/precanned/utilization.html
GET /projects/api/v3/reporting/precanned/utilization.pdf

Generates a utilization report in PDF format containing all people for the
provided filters. Only the people that the logged-in user can access will
be returned.

operationId: People_generateUtilizationReportPdf

Parameters

Name In Required Type Description
zoom query optional string

determine the type of zoom filter used to display on the report

startDate query optional string

filter by start date

sortOrder query optional string

order mode

sort query optional string

sort by (deprecated, use orderBy)

searchTerm query optional string

filter by user first or last name

reportFormat query optional string

define the format of the report

orderMode query optional string

group by

orderBy query optional string

sort by

groupBy query optional string

group by

endDate query optional string

filter by end date

pageSize query optional integer

number of items in a page

page query optional integer

page number

skipCounts query optional boolean

SkipCounts allows you to skip doing counts on a list API endpoint for
performance reasons.

isReportDownload query optional boolean

generate a report document

isCustomDateRange query optional boolean

determine if the query is for a custom date range

includeCollaborators query optional boolean

include collaborators

includeClients query optional boolean

include client users

userIds query optional array

filter by userIds

teamIds query optional array

filter by team ids

selectedColumns query optional array

customise the report by selecting columns to be displayed.

projectIds query optional array

filter by project ids

include query optional array

include

fields[utilizations] query optional array
fields[users] query optional array
companyIds query optional array

filter by company ids

Responses

200

200 OK (no data)

400

400 Bad Request

GET /projects/api/v3/reporting/precanned/utilization.pdf
GET /projects/api/v3/reporting/precanned/utilization.xlsx

Generates a utilization report in XLSX format containing all people for the
provided filters. Only the people that the logged-in user can access will
be returned.

operationId: People_generateUtilizationXlsx

Parameters

Name In Required Type Description
zoom query optional string

determine the type of zoom filter used to display on the report

startDate query optional string

filter by start date

sortOrder query optional string

order mode

sort query optional string

sort by (deprecated, use orderBy)

searchTerm query optional string

filter by user first or last name

reportFormat query optional string

define the format of the report

orderMode query optional string

group by

orderBy query optional string

sort by

groupBy query optional string

group by

endDate query optional string

filter by end date

pageSize query optional integer

number of items in a page

page query optional integer

page number

skipCounts query optional boolean

SkipCounts allows you to skip doing counts on a list API endpoint for
performance reasons.

isReportDownload query optional boolean

generate a report document

isCustomDateRange query optional boolean

determine if the query is for a custom date range

includeCollaborators query optional boolean

include collaborators

includeClients query optional boolean

include client users

userIds query optional array

filter by userIds

teamIds query optional array

filter by team ids

selectedColumns query optional array

customise the report by selecting columns to be displayed.

projectIds query optional array

filter by project ids

include query optional array

include

fields[utilizations] query optional array
fields[users] query optional array
companyIds query optional array

filter by company ids

Responses

200

200 OK (no data)

400

400 Bad Request

GET /projects/api/v3/reporting/precanned/utilization.xlsx

Peoplestatus 2 endpoints

GET /projects/api/v3/statuses.json

All of the latest status posts are returned for all users in the parent
company.

operationId: PeopleStatus_getAllStatuses

Parameters

Name In Required Type Description
updatedAfter query optional string

return only statuses updated after a specific date

searchTerm query optional string

filter by the user name or status message

teamId query optional integer

filter by team

pageSize query optional integer

number of items in a page

page query optional integer

page number

skipCounts query optional boolean

SkipCounts allows you to skip doing counts on a list API endpoint for
performance reasons.

showEveryone query optional boolean

show also users without status

showDeleted query optional boolean

showDeleted statuses

includeSubteams query optional boolean

also include statuses from subteams

include query optional array

include

fields[users] query optional array
fields[statuses] query optional array

Responses

200

200 OK

400

400 Bad Request

GET /projects/api/v3/statuses.json
GET /projects/api/v3/statuses/timeline.json

Return a timeline list of people statuses that the logged-in user can access.

operationId: PeopleStatus_listTimeline

Parameters

Name In Required Type Description
searchTerm query optional string

filter by the user name or status message

teamId query optional integer

filter by team

pageSize query optional integer

number of items in a page

page query optional integer

page number

skipCounts query optional boolean

SkipCounts allows you to skip doing counts on a list API endpoint for
performance reasons.

showDeleted query optional boolean

showDeleted statuses

includeSubteams query optional boolean

also include statuses from subteams

include query optional array

include

fields[users] query optional array

Responses

200

200 OK

400

400 Bad Request

GET /projects/api/v3/statuses/timeline.json
Load more endpoints